<template>
  <div>
    <div v-if="isLoading" class="row col">
      <p>Loading..</p>
    </div>
    <div v-else-if="hasError" class="row col">
      <div class="alert alert-danger" role="alert">
        {{ error }}
      </div>
    </div>
    <div v-else-if="!hasHelps" class="row col">
      <p class="alert color-green"> {{ this.message }} </p>
    </div>
    <div v-else >
      <BlocItem v-for="help in helps"
                :item="help"
                :show-btn="false"
      ></BlocItem>
      <nav aria-label="Page navigation">
        <ul class="pagination">
          <li class="page-item">
            <button class="page-link" type="button" v-if="page != 1" @click="page--"><<</button>
          </li>
          <li class="page-item">
            <button class="page-link" type="button" v-for="pageNumber in pages.slice(page-1, page+5)" @click="page = pageNumber">{{ pageNumber }}</button>
          </li>
          <li class="page-item">
            <button class="page-link" type="button" v-if="page < pages.length" @click="page++">>></button>
          </li>
        </ul>
      </nav>
    </div>
  </div>
</template>

<script>

import BlocItem from "./BlocItem";
export default {
  name: "HelpAccepted",
  components: {BlocItem},
  props: {
    message: {
      type: String
    }
  },
  data() {
    return {
      items: [],
      emptyItems: true,
      isArray: false,
      addressBis: false,
      page: 1,
      perPage: 5,
      pages: []
    }
  },
  methods: {
    setPages() {
      let numberOfPages = Math.ceil(this.items.length / this.perPage)
      for (let index = 1; index <= numberOfPages; index++) {
        this.pages.push(index)
      }
    },
    paginate(items) {
      let page = this.page
      let perPage = this.perPage
      let from = (page*perPage)-perPage
      let to = (page * perPage)
      return items.slice(from, to)
    }
  },
  computed: {
    isLoading() {
      return this.$store.getters['helpAccepted/isLoading']
    },
    hasError() {
      return this.$store.getters['helpAccepted/hasError']
    },
    error() {
      return this.$store.getters['helpAccepted/error']
    },
    hasHelps() {
      return this.$store.getters['helpAccepted/hasHelps']
    },
    helps() {
      this.items = this.$store.getters['helpAccepted/helps']
      return this.paginate(this.items)
    }
  },
  watch: {
    items: function() {
      this.setPages()
    }
  },
  created() {
    this.$store.dispatch('helpAccepted/findAllAccepted')
  },
  filters: {
    trimWords(value) {
      return value.split(" ").splice(0,20).join(" ")+ '...'
    }
  }
}
</script>

<style scoped>
  button.page-link {
    display: inline-block;
    font-size: 20px;
    color: #6d3e2e;
    background-color: #ffffff;
    font-weight: 500;
  }
  .offset {
    width: 500px !important;
    margin: 20px auto;
  }
</style>